DECLARE SUB AddColorText (WindowVal%, TextData AS STRING)
DECLARE SUB DrawWindow (Top AS INTEGER, LEFT AS INTEGER, Wid AS INTEGER, Hei AS INTEGER, WindowTitle AS STRING)
DECLARE SUB Shutdown ()
DECLARE SUB MouseTasks ()
DECLARE SUB ScrollBuffer (WindowVal%, LinesVal%)
DECLARE SUB UpdateScreen ()
DECLARE SUB AddText (WindowVal%, TextData AS STRING)
DECLARE SUB DrawTitleBar (TitleText$)
DECLARE SUB MouseHide ()
DECLARE SUB DrawScreenBack ()
DECLARE SUB CenterPrint (writetext$, whereY%)
DECLARE SUB ScreenWrite (writetext$, writeY%, writeX%)

'Mouse-related declares here:
DECLARE SUB MouseShow ()
DECLARE SUB MouseUpdate ()
DECLARE SUB MouseReset ()
DECLARE FUNCTION VerifyMouse% ()

'TCP-related declares here:
DECLARE SUB Disconnect (socketID%)
DECLARE FUNCTION FreeSock% ()
DECLARE FUNCTION SendData% (socketID%, strData$)
DECLARE FUNCTION IsOpen% (socketID%)
DECLARE FUNCTION GetData$ (socketID%)
DECLARE FUNCTION Connect% (socketID%, ipAdr$, portNr%)
DECLARE FUNCTION VerifyTCP% ()

'Other routines declared here:
DECLARE SUB DoTask.InitClient ()

'$INCLUDE: 'leetirc.bi'
'$INCLUDE: 'cosmox.bi'
DEFINT A-Z

DIM SHARED tcpIn AS RegType, tcpOut AS RegType
DIM SHARED PufSeg%, PufOffs%

DIM SHARED TCPMode AS INTEGER
DIM SHARED BackBuffer AS INTEGER
DIM SHARED RegsIn AS RegType, RegsOut AS RegType
DIM SHARED ScreenHeight AS INTEGER
DIM SHARED CurWindow AS INTEGER
DIM SHARED Mouse AS MouseType
DIM SHARED SysInfo.CPU AS INTEGER
DIM SHARED SysInfo.XMS AS INTEGER
DIM SHARED ScreenBuffer(0 TO 10, 1 TO 20) AS STRING * 156
DIM SHARED LocalInput AS STRING
DIM SHARED MouseMode AS INTEGER

ScreenHeight = 25
BackBuffer = 0
WindowVal = 0

SCREEN 0: WIDTH 80, ScreenHeight: COLOR 7, 0: CLS
MouseReset
DoTask.InitClient
MouseShow

LOCATE 25, 1, 1
DO
key$ = INKEY$
SELECT CASE key$
	CASE ""

	CASE CHR$(0) + CHR$(16) 'Alt+Q shutdown shortcut
		Shutdown

	CASE CHR$(8)
		IF LEN(LocalInput) > 0 THEN LocalInput = LEFT$(LocalInput, LEN(LocalInput) - 1)
	CASE CHR$(13), CHR$(10)
		'DoLocalTask LocalInput
	CASE CHR$(27)
		LocalInput = ""
	CASE ELSE
		IF LEN(LocalInput) < 256 THEN
			LocalInput = LocalInput + key$
		ELSE
			BEEP
		END IF
END SELECT

IF key$ <> "" THEN
	COLOR 7, 0
	LOCATE 25, 1
	newcurpos = LEN(LocalInput) + 1: IF newcurpos > 80 THEN newcurpos = 80
	displocal$ = LEFT$(RIGHT$(LocalInput, 79) + SPACE$(80), 80)
	MouseHide
	PRINT displocal$; : LOCATE 25, newcurpos, 1
	MouseShow
END IF

IF MouseMode = 1 THEN MouseTasks
LOOP

SUB AddColorText (WindowVal, TextData AS STRING)
ScrollBuffer WindowVal, 1
ScreenBuffer(WindowVal, 20) = LEFT$(TextData + STRING$(156, CHR$(0)), 156)
END SUB

SUB AddText (WindowVal, TextData AS STRING)
curcolor = 7
newtext$ = ""
FOR tempvar = 1 TO LEN(TextData)
	newtext$ = newtext$ + MID$(TextData, tempvar, 1) + CHR$(curcolor)
NEXT tempvar

'newtext$ = TextData
ScrollBuffer WindowVal, 1
ScreenBuffer(WindowVal, 20) = LEFT$(newtext$ + STRING$(156, CHR$(0)), 156)
END SUB

SUB CenterPrint (writetext$, whereY)
LOCATE whereY, 40 - INT(LEN(writetext$) / 2)
PRINT writetext$;
END SUB

DEFSNG A-Z
FUNCTION Connect% (socketID%, ipAdr$, portNr%)
DEF SEG = PufSeg%

ipBin$ = ""
DO
	p% = INSTR(ipAdr$, ".")
	IF p% = 0 THEN EXIT DO
	ipBin$ = ipBin$ + CHR$(VAL(LEFT$(ipAdr$, p% - 1)))
	ipAdr$ = MID$(ipAdr$, p% + 1)
LOOP
ipBin$ = ipBin$ + CHR$(VAL(ipAdr$))

'Make sure supplied remote IP is valid.
IF LEN(ipBin$) <> 4 THEN Connect = 0: EXIT FUNCTION

tcpIn.ax = &H300
tcpIn.cx = 1
tcpIn.dx = socketID%
CALL INTERRUPT(&H17, tcpIn, tcpOut)
IF tcpOut.ax <> 0 THEN 'If error occurs while trying to connect.
	Connect = 0
	EXIT FUNCTION
END IF

PufSeg% = tcpOut.cx
PufOffs% = tcpOut.dx
DEF SEG = PufSeg%

tcpIn.ax = &H500
tcpIn.dx = socketID%
rsockaddr$ = RIGHT$(MKI$(portNr%), 1) + LEFT$(MKI$(portNr%), 1) + ipBin$

FOR i% = 1 TO LEN(rsockaddr$)
	POKE PufOffs% + i% + 1, ASC(MID$(rsockaddr$, i%, 1))
NEXT i%

CALL INTERRUPT(&H17, tcpIn, tcpOut)
IF tcpOut.ax <> 0 THEN 'If connection error occurs.
	Connect = 0
	tcpIn.ax = &HD00
	CALL INTERRUPT(&H17, tcpIn, tcpOut)
	EXIT FUNCTION
END IF

tcpIn.ax = &HB00
tcpIn.dx = socketID%
CALL INTERRUPT(&H17, tcpIn, tcpOut)
Connect = 1
END FUNCTION

SUB Disconnect (socketID%)
DEF SEG = PufSeg%

tcpIn.ax = &HC00
tcpIn.dx = socketID%
CALL INTERRUPT(&H17, tcpIn, tcpOut)

tcpIn.ax = &HD00
CALL INTERRUPT(&H17, tcpIn, tcpOut)
END SUB

DEFINT A-Z
SUB DoTask.InitClient
LOCATE , , 0
DrawScreenBack
MouseHide

DrawWindow 12, 20, 40, 6, "Welcome"

CenterPrint "leetIRC v0.5 (c)2006 Mike Chambers", 13
CenterPrint "http://www.rubbermallet.org/", 14

COLOR 0, 7
CenterPrint "  OK  ", 16
COLOR 7, 0
MouseShow

'Wait for ENTER or click OK
DO
	IF INKEY$ = CHR$(13) THEN Continue = 1
	MouseUpdate
	IF Mouse.LEFT = 1 AND Mouse.Y = 16 AND Mouse.X >= 37 AND Mouse.X <= 42 THEN Continue = 1
LOOP UNTIL Continue
DrawScreenBack

AddColorText 0, "- Welcome to leetIRC v0.5 (c)2006 Mike Chambers"
AddColorText 0, "- Visit h	t	t	p	:	/	/	r	u	b	b	e	r	m	a	l	l	e	t	.	o	r	g	 for updates."
AddText 0, "-"
AddText 0, "- Detecting system settings..."
UpdateScreen

'Hardware detection
AddText 0, "- CPU ID: " + RTRIM$(CSProcessor$) + " (" + MID$(STR$(CSDetectCPU%), 2) + " class)": UpdateScreen

IF VerifyMouse% THEN
	mousestring$ = "Detected"
	MouseMode = 1
ELSE
	mousestring$ = "Not detected"
	MouseMode = 0
END IF
AddText 0, "- Mouse driver: " + mousestring$: UpdateScreen

IF VerifyTCP% = 1 THEN
	tcpstring$ = "DOS type detected (Waterloo TCP or compatible)"
	TCPMode% = 1
ELSE
	tcpstring$ = "Not detected"
	TCPMode% = 0
END IF
AddText 0, "- TCP layer: " + tcpstring$: UpdateScreen

'IF CSDetectXMS% THEN
'        memstring$ = "XMS detected" '(" + MID$(STR$(CSFreeXMS&), 2) + " KB free)"
'        BackBuffer = 1
'ELSE
'        BackBuffer = 0
'        IF CSDetectEMS% THEN
'                memstring$ = "EMS detected" '(" + MID$(STR$(CSFreeEMS&), 2) + " KB free)"
'                BackBuffer = 2
'        END IF
'END IF

'IF BackBuffer = 1 AND CSFreeXMS& < 512 THEN
'        IF CSDetectEMS% THEN
'                memstring$ = "EMS detected" '(" + MID$(STR$(CSFreeEMS&), 2) + " KB free)"
'                BackBuffer = 2
'        END IF
'END IF
'IF BackBuffer = 2 AND CSFreeEMS& < 512 THEN BackBuffer = 0: memstring$ = "Detected, but insufficient free XMS/EMS"
BackBuffer = 0
memstring$ = "Not detected"

AddText 0, "- XMS/EMS memory: " + memstring$
AddText 0, "-": UpdateScreen

IF BackBuffer = 0 THEN
	DrawWindow 11, 20, 41, 7, "Memory error"
	CenterPrint "Insufficient free XMS/EMS for log", 12
	CenterPrint "scrolling. Would you like to allocate", 13
	CenterPrint "512 KB on the hard drive as memory?", 14
       
	COLOR 0, 7: LOCATE 16, 30
	PRINT "  "; : COLOR 2, 7: PRINT "Y"; : COLOR 0, 7: PRINT "es  "
	COLOR 0, 7: LOCATE 16, 42
	PRINT "   "; : COLOR 2, 7: PRINT "N"; : COLOR 0, 7: PRINT "o  "
	COLOR 7, 0
	MouseShow
       
	DO
		MouseUpdate
		SELECT CASE LCASE$(INKEY$)
		CASE "y"
			Mouse.LEFT = 1
			Mouse.Y = 16
			Mouse.X = 30
		CASE "n", CHR$(27)
			Mouse.LEFT = 1
			Mouse.Y = 16
			Mouse.X = 42
		END SELECT

		IF Mouse.LEFT = 1 AND Mouse.Y = 16 THEN
			IF Mouse.X >= 30 AND Mouse.X <= 36 THEN
				AddText 0, "- Please wait, allocating 512 KB file on disk. This may take a minute."
				MouseHide
				UpdateScreen
				MouseShow

				OPEN "swap.tmp" FOR OUTPUT AS #1
				tempstr1$ = STRING$(1024, CHR$(0))
				FOR tempvar1 = 1 TO 512
					PRINT #1, tempstr1$;
				NEXT tempvar1
				tempstr1$ = ""
				CLOSE #1
				BackBuffer = 3
				AddText 0, "- Ok, using 512 KB file as virtual memory."
				MouseHide
				UpdateScreen
				EXIT DO
			END IF
			IF Mouse.X >= 42 AND Mouse.X <= 48 THEN
				BackBuffer = 0
				AddText 0, "- Due to insufficient memory, log scrolling is disabled."
				EXIT DO
			END IF
		END IF
	LOOP
	MouseHide
	UpdateScreen
END IF

IF TCPMode% = 0 THEN
	AddText 0, "-"
	AddText 0, "- Error: Unable to detect a suitable TCP sockets layer."
	AddText 0, "-        You will be UNABLE to connect to a server."
	UpdateScreen
END IF

AddText 0, "-"
AddText 0, "- leetIRC initialized, and ready for use.": UpdateScreen
MouseShow
END SUB

SUB DrawScreenBack
MouseHide
COLOR 0, 4: LOCATE 1, 1
PRINT SPACE$(76) + " ";
COLOR 2, 4: LOCATE 1, 3: PRINT "F"; : COLOR 15, 4: PRINT "ile     "; : COLOR 2, 4: PRINT "O"; : COLOR 15, 4: PRINT "ptions     "; : COLOR 2, 4: PRINT "W"; : COLOR 15, 4: PRINT "indow"

COLOR 15, 0: LOCATE 1, 77: PRINT "[X]";

DrawTitleBar "Status"
COLOR 13, 0
LOCATE 3, 1
PRINT "" + STRING$(78, CHR$(0));
COLOR 0, 7
PRINT "";
COLOR 13, 0
FOR tempvar = 1 TO 18
	PRINT "" + STRING$(78, CHR$(0));
	COLOR 0, 7
	PRINT "";
	COLOR 13, 0
NEXT tempvar
PRINT "" + STRING$(78, CHR$(0));
COLOR 0, 7
PRINT "";
COLOR 13, 0
PRINT "" + STRING$(78, "") + "";
COLOR 0, 7
PRINT SPACE$(80);
COLOR 7, 0
MouseShow
END SUB

SUB DrawTitleBar (TitleText AS STRING)
IF LEN(TitleText) > 73 THEN TitleText = LEFT$(TitleText, 70) + "..."
remainder = 73 - LEN(TitleText)
COLOR 13, 0
LOCATE 2, 1
PRINT "͹ ";
COLOR 15, 0
PRINT TitleText;
COLOR 13, 0
PRINT " " + STRING$(remainder, "") + "";
END SUB

SUB DrawWindow (Top AS INTEGER, LEFT AS INTEGER, Wid AS INTEGER, Hei AS INTEGER, WindowTitle AS STRING)
tmpvar = Wid - (7 + LEN(WindowTitle))

COLOR 15, 1
ScreenWrite "͹ " + WindowTitle + " " + STRING$(tmpvar, "") + "", Top, LEFT
FOR tempvar = Top + 1 TO Top + Hei - 2
	ScreenWrite "" + SPACE$(Wid - 2) + "", tempvar, LEFT
NEXT tempvar
ScreenWrite "" + STRING$(Wid - 2, "") + "", tempvar, LEFT

END SUB

DEFSNG A-Z
FUNCTION FreeSock%
FOR ntemp% = 1 TO 32767
	IF IsOpen(ntemp%) THEN FreeSock% = ntemp%: EXIT FUNCTION
NEXT ntemp%
IF ntemp% = 32768 THEN FreeSock% = 0
END FUNCTION

FUNCTION GetData$ (socketID%)
DEF SEG = PufSeg%

Continue% = -1
DO UNTIL Continue% = 0
	Z$ = ""
	tcpIn.ax = &H800
	tcpIn.cx = 1024
	tcpIn.dx = socketID%
	CALL INTERRUPT(&H17, tcpIn, tcpOut)
	IF tcpOut.ax = -1 THEN
		IF tcpOut.cx = 35 THEN
			'Ignore
		ELSEIF tcpOut.cx = 6 THEN
			'If peer closes the connection.
			Continue% = 0
			EXIT DO
		ELSE
			Disconnect socketID%
			EXIT FUNCTION
		END IF
	ELSE
		FOR i% = 0 TO tcpOut.ax - 1
			Z$ = Z$ + CHR$(PEEK(PufOffs% + 16 + i%))
		NEXT i%
	END IF
	IF Z$ = "" THEN EXIT DO ELSE GetData$ = Z$
LOOP
END FUNCTION

FUNCTION IsOpen% (socketID%)
DEF SEG = PufSeg%

tcpIn.ax = &H800
tcpIn.cx = 0
tcpIn.dx = socketID%
CALL INTERRUPT(&H17, tcpIn, tcpOut)
IF tcpOut.ax = 2048 THEN
	IsOpen = 1
ELSE
	IsOpen = 0
END IF
END FUNCTION

DEFINT A-Z
SUB MouseHide
RegsIn.ax = 2
CALL INTERRUPT(&H33, RegsIn, RegsOut)
END SUB

SUB MouseReset
IF VerifyMouse% THEN
	RegsIn.ax = 7
	RegsIn.cx = 0
	RegsIn.dx = 632
	CALL INTERRUPT(&H33, RegsIn, RegsOut)

	IF ScreenHeight = 25 THEN mh% = 192 ELSE mh% = 384
	RegsIn.ax = 8
	RegsIn.cx = 0
	RegsIn.dx = mh%
	CALL INTERRUPT(&H33, RegsIn, RegsOut)

	MouseShow
END IF
END SUB

SUB MouseSetPos (setX%, setY%)
RegsIn.ax = 4
RegsIn.bx = (setX% - 1) * 8
RegsIn.cx = (setY% - 1) * 8
CALL INTERRUPT(&H33, RegsIn, RegsOut)
END SUB

SUB MouseShow
RegsIn.ax = 1
CALL INTERRUPT(&H33, RegsIn, RegsOut)
END SUB

SUB MouseTasks
MouseUpdate
IF Mouse.Y = 1 AND Mouse.LEFT = 1 THEN
	SELECT CASE Mouse.X
	CASE 77, 78, 79
		Shutdown
	END SELECT
END IF
END SUB

SUB MouseUpdate
RegsIn.ax = 3
RegsIn.bx = 0
CALL INTERRUPT(&H33, RegsIn, RegsOut)
IF RegsOut.bx = 1 OR RegsOut.bx = 3 THEN Mouse.LEFT = 1 ELSE Mouse.LEFT = 0
IF RegsOut.bx = 2 OR RegsOut.bx = 3 THEN Mouse.RIGHT = 1 ELSE Mouse.RIGHT = 0
Mouse.X = FIX((RegsOut.cx + 8) / 8)
Mouse.Y = FIX((RegsOut.dx + 8) / 8)
END SUB

SUB ScreenWrite (writetext$, writeY, writeX)
LOCATE writeY, writeX
PRINT writetext$;
END SUB

SUB ScrollBuffer (WindowVal, LinesVal)
WindowVal = 0
SELECT CASE BackBuffer
	CASE 0, 3 'Simple method, no back logs kept for scrolling
		FOR tempvar = 2 TO 20
			ScreenBuffer(WindowVal, tempvar - 1) = ScreenBuffer(WindowVal, tempvar)
		NEXT tempvar
		ScreenBuffer(WindowVal, 20) = STRING$(78, CHR$(0))

	CASE 1 'XMS method

	CASE 2 'EMS method

	'CASE 3 'Virtual memory swap file method

END SELECT
END SUB

DEFSNG A-Z
FUNCTION SendData% (socketID%, strData$)
DEF SEG = PufSeg%

sID% = socketID%
t$ = strData$
Continue% = -1
WHILE Continue%
	IF t$ <> "" THEN
		WHILE t$ <> ""
			tcpIn.ax = &H900
			tcpIn.cx = LEN(t$)
			tcpIn.dx = socketID%
			FOR i% = 0 TO LEN(t$) - 1
				POKE PufOffs% + 16 + i%, ASC(MID$(t$, i% + 1, 1))
			NEXT i%
			CALL INTERRUPT(&H17, tcpIn, tcpOut)
			IF tcpOut.ax < 0 THEN 'If there is an error sending data.
				Disconnect (sID%)
				SendData = 0
				EXIT FUNCTION
			END IF
			t$ = MID$(t$, tcpOut.ax + 1)
		WEND
	END IF
IF t$ = "" THEN SendData = 1: EXIT FUNCTION
WEND
SendData = 1
END FUNCTION

DEFINT A-Z
SUB Shutdown
DrawWindow 11, 20, 41, 7, "Shutdown"
CenterPrint "Shutting down leetIRC will cause you", 12
CenterPrint "to disconnect from any server, and", 13
CenterPrint "exit to DOS. Are you sure?", 14
COLOR 0, 7: LOCATE 16, 30
PRINT "  "; : COLOR 2, 7: PRINT "Y"; : COLOR 0, 7: PRINT "es  "
COLOR 0, 7: LOCATE 16, 42
PRINT "   "; : COLOR 2, 7: PRINT "N"; : COLOR 0, 7: PRINT "o  "
COLOR 7, 0
MouseShow
DO
MouseUpdate
SELECT CASE LCASE$(INKEY$)
CASE "y"
Mouse.LEFT = 1
Mouse.Y = 16
Mouse.X = 30
CASE "n", CHR$(27)
Mouse.LEFT = 1
Mouse.Y = 16
Mouse.X = 42
END SELECT
IF Mouse.LEFT = 1 AND Mouse.Y = 16 THEN
	IF Mouse.X >= 30 AND Mouse.X <= 36 THEN
		CurWindow = 0
		AddText 0, "-"
		AddText 0, "- User terminated leetIRC session."
		AddText 0, "- Killing all socket sessions."
		UpdateScreen
		FOR tempvar% = 1 TO 1024
			IF IsOpen(tempvar%) THEN Disconnect tempvar%
		NEXT tempvar%
		AddText 0, "- Dropping to DOS..."
		UpdateScreen
		MouseHide
		COLOR 7, 0
		END
	END IF
	IF Mouse.X >= 42 AND Mouse.X <= 48 THEN
		MouseHide
		UpdateScreen
		MouseShow
		EXIT SUB
	END IF
END IF
LOOP
END SUB

SUB UpdateScreen
curmemloc = 322
FOR tempvar = 1 TO 20
	CSMemCopy VARSEG(ScreenBuffer(CurWindow, tempvar)), VARPTR(ScreenBuffer(CurWindow, tempvar)), &HB800, curmemloc, 156
	curmemloc = curmemloc + 160
NEXT tempvar
END SUB

FUNCTION VerifyMouse%
RegsIn.ax = 0
CALL INTERRUPT(&H33, RegsIn, RegsOut)
VerifyMouse% = RegsOut.ax
END FUNCTION

DEFSNG A-Z
FUNCTION VerifyTCP%
tcpIn.ax = &HE00
CALL INTERRUPT(&H17, tcpIn, tcpOut)
IF tcpOut.cx <> &H1234 THEN
	VerifyTCP = 0
ELSE
	VerifyTCP = 1
END IF
END FUNCTION

